red = "#FF0000";
blue = "#0000FF";

function popUpNote(e) {

	var node, doc, leftPos, topPos, nWidth, offsetX, offsetY, event;

	// Determine the event that triggered the popup.
	event = window.event ? window.event : e;
	// Set the font color and style of the active element.
	setTagFontColor(this, red);
	//setTagFontStyle(this, "italic");
	// Find the invisible div containing the desired note.
	div = getLayer(document,this.targetDiv);
	// If it's not prepositioned, position it near the cursor.
	if (!isPositioned(div)) {
		nWidth  = layerWidth(div);
		topPos  = mousePosTop(event) + 30;
		topPos  = Math.max(topPos, 50);
		leftPos = mousePosLeft(event) - nWidth/2;
		if (!isNaN(window.innerWidth)) {
			leftPos = Math.min(window.innerWidth - nWidth - 50, leftPos);
		}
		leftPos = Math.max(leftPos, 50);
		//alert("topPos = " + topPos + ", leftPos = " + leftPos);
		setLayerPos(div, leftPos, topPos);
	}
	// Make it visible.
	showLayer(div);
}

function popDownNote(name) {

	var note;

	// Find the div containing the desired note.
	note = getLayer(document,name);
	// Make it hidden.
	hideLayer(note);
}

function setPopDownNote() {

	var note,name;

	// Reset the footnote style.
	setTagFontColor(this, blue);
	setTagFontStyle(this, "normal");
	// Set the clearing action.
	name = this.targetDiv;
	note = getLayer(document, name);
	//alert("note.timeout = " + note.timeout);
	if (note.timeout) {
		setTimeout("popDownNote(\"" + name + "\")", note.timeout*1000);
	} else {
		popDownNote(name);
	}
}

function activateNotes(tagType, onMouseOverFunc, onMouseOutFunc, modifyTag) {

	var tagList;
	var tag,tagNode;

	if (is.ie4) {
		tagList = document.all.tags(tagType);
	} else if (is.w3c) {
		tagList = document.getElementsByTagName(tagType);
	} else if (is.ns4) {
		if (tagType.toLowerCase() == "a") {
			tagList = document.anchors;
		} else if (tagType.toLowerCase() == "area") {
			tagList = document.links;
		} else {
			return;
		}
	}
	for (tag = 0; tag < tagList.length; tag++) {
		if (is.ie4 || is.w3c) {
			tagNode = tagList.item(tag);
		} else if (is.ns4) {
			tagNode = tagList[tag];
		}
		if ((tagNode.className == "note") && (tagNode.name)) {	// Whatever is supported!
			tagNode.onmouseover = onMouseOverFunc;
			tagNode.onmouseout  = onMouseOutFunc;
			if (modifyTag) modifyTag(tagNode);
			tagNode.targetDiv = "note" + tagNode.name;
		}
	}
}

function formatFootnote(tagNode) {

	var newHTML;

	tagNode.style.cursor = "hand";
	newHTML = "[" + tagNode.name + "]";
	tagNode.innerHTML = newHTML;
}

function activateFootnotes(tagType) {

	activateNotes(tagType, popUpNote, setPopDownNote, formatFootnote);
}

function popInNote(e) {

	var div,dName;

	// Set the font color and style of the active element.
	setTagFontColor(this, red);
	setTagFontStyle(this, "italic");
	// Find the div containing the desired note.
	dName = this.targetDiv;
	div = getLayer(document,dName);
	// Expand it.
	expandLayer(div);
}

function popOutNote() {

	var div,dName;

	// Reset the font color and style of the active element.
	setTagFontColor(this, blue);
	setTagFontStyle(this, "normal");
	// Find the div containing the desired note.
	dName = this.targetDiv;
	div = getLayer(document,dName);
	// Contract it.
	contractLayer(div);
}

function activatePopIns(tagType) {

	activateNotes(tagType, popInNote, popOutNote);
}

function formatQuotes() {

	var tagList;
	var tag,tagNode;

	if (is.ie4) {
		tagList = document.all.tags("DIV");
	} else if (is.w3c) {
		tagList = document.getElementsByTagName("DIV");
	} else {
		return;
	}
	for (tag = 0; tag < tagList.length; tag++) {
		tagNode = tagList.item(tag);
		if (tagNode.className == "quote") {	// Note: this doesn't yet work in Netscape 6.
			if (tagNode.cite) {
				tagNode.innerHTML = tagNode.innerHTML + " [" + tagNode.cite + "]";
			}
		}
	}
}